<?php

/**
 * Import/Export plugin
 *
 *
 * Created: 2007-05-17
 * Last update: 2007-05-17
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

function plugins_importexport_add_bug( &$p_id, $p_ptr ) {
    global $g_mantis_is_11x_release;
    
    $t_bug_data = new BugData;
    $t_bug_data->build = gpc_get_string( 'build_' . $p_ptr, '' );
    $t_bug_data->platform = gpc_get_string( 'platform_' . $p_ptr, '' );
    $t_bug_data->os = gpc_get_string( 'os_' . $p_ptr, '' );
    $t_bug_data->os_build = gpc_get_string( 'os_build_' . $p_ptr, '' );
    $t_bug_data->version = gpc_get_string( 'product_version_' . $p_ptr, '' );
    $t_bug_data->profile_id = gpc_get_int( 'profile_id_' . $p_ptr, 0 );
    $t_bug_data->handler_id = gpc_get_int( 'handler_id_' . $p_ptr, 0 );
    $t_bug_data->view_state = gpc_get_int( 'view_state_' . $p_ptr, config_get( 'default_bug_view_status' ) );
    $t_bug_data->category = gpc_get_string( 'category_' . $p_ptr, config_get( 'default_bug_category' ) );
    $t_bug_data->reproducibility = gpc_get_int( 'reproducibility_' . $p_ptr, config_get( 'default_bug_reproducibility' ) );
    $t_bug_data->severity = gpc_get_int( 'severity_' . $p_ptr, config_get( 'default_bug_severity' ) );
    $t_bug_data->priority = gpc_get_int( 'priority_' . $p_ptr, config_get( 'default_bug_priority' ) );
    $t_bug_data->summary = gpc_get_string( 'summary_' . $p_ptr, '' );
    $t_bug_data->description = gpc_get_string( 'description_' . $p_ptr, '' );
    $t_bug_data->steps_to_reproduce = gpc_get_string( 'steps_to_reproduce_' . $p_ptr, '' );
    $t_bug_data->additional_information	= gpc_get_string( 'additional_information_' . $p_ptr, config_get( 'default_bug_additional_info' ) );

    $t_bug_data->project_id = gpc_get_int( 'project_id_' . $p_ptr, 0 );
    $t_bug_data->reporter_id = gpc_get_int( 'reporter_id_' . $p_ptr, 0 );
    $t_bug_data->summary = trim( $t_bug_data->summary );

    if ( $t_bug_data->summary == '' || $t_bug_data->description == '' || $t_bug_data->project_id == 0 ) {
        return false;
    }
    if ( $t_bug_data->reporter_id == 0 ) {
        $t_username = gpc_get_string( 'reporter_useranme_' . $p_ptr, '' );
        if ( $t_username == '' ) {
            $t_bug_data->reporter_id = auth_get_current_user_id();
        } else {
            $t_bug_data->reporter_id = user_get_id_by_name( $t_username );
        }
    }
    
    if ( 0 != $t_bug_data->profile_id ) {
        if ( profile_is_global( $t_bug_data->profile_id ) ) {
            $row = user_get_profile_row( ALL_USERS, $t_bug_data->profile_id );
        } else {
            $row = user_get_profile_row( $t_bug_data->reporter_id, $t_bug_data->profile_id );
        }

        if ( is_blank( $t_bug_data->platform ) ) {
            $t_bug_data->platform = $row['platform'];
        }
        if ( is_blank( $t_bug_data->os ) ) {
            $t_bug_data->os = $row['os'];
        }
        if ( is_blank( $t_bug_data->os_build ) ) {
            $t_bug_data->os_build = $row['os_build'];
        }
    }

    helper_call_custom_function( 'issue_create_validate', array( $t_bug_data ) );

    $t_related_custom_field_ids = custom_field_get_linked_ids( $t_bug_data->project_id );
    foreach( $t_related_custom_field_ids as $t_id ) {
        $t_def = custom_field_get_definition( $t_id );
        if ( $t_def['require_report'] && ( gpc_get_custom_field( 'custom_' . $t_def['name'] . '_' . $p_ptr, $t_def['type'], '' ) == '' ) ) {
            return false;
        }
        if ( !custom_field_validate( $t_id, gpc_get_custom_field( 'custom_' . $t_def['name'] . '_' . $p_ptr, $t_def['type'], $t_def['default_value'] ) ) ) {
            return false;
        }
    }

    $p_id = bug_create( $t_bug_data );

    foreach( $t_related_custom_field_ids as $t_id ) {
        if( !custom_field_has_write_access( $t_id, $p_id ) ) {
            continue;
        }
        
        $t_def = custom_field_get_definition( $t_id );
        if( !custom_field_set_value( $t_id, $p_id, gpc_get_custom_field( 'custom_' . $t_def['name'] . '_' . $p_ptr, $t_def['type'], $t_def['default_value'] ) ) ) {
            return false;
        }
    }

    email_new_bug( $p_id );
    helper_call_custom_function( 'issue_create_notify', array( $p_id ) );

    return true;
}

function plugins_importexport_update_bug( $p_id, $p_ptr ) {
    global $g_mantis_is_11x_release;
    
    $f_new_status = gpc_get_int( 'status_' . $p_ptr, bug_get_field( $p_id, 'status' ) );
    $t_bug_data = bug_get( $p_id, true );
    if( $t_bug_data->project_id != helper_get_current_project() ) {
        $g_project_override = $t_bug_data->project_id;
    }

    if ( !( ( access_has_bug_level( access_get_status_threshold( $f_new_status, bug_get_field( $p_id, 'project_id' ) ), $p_id ) ) ||
           ( access_has_bug_level( config_get( 'update_bug_threshold' ) , $p_id ) ) ||
           ( ( bug_get_field( $p_id, 'reporter_id' ) == auth_get_current_user_id() ) &&
            ( ( ON == config_get( 'allow_reporter_reopen' ) ) ||
             ( ON == config_get( 'allow_reporter_close' ) ) ) )
           ) ) {
        return false;
    }

    $t_old_bug_status = $t_bug_data->status;

    $t_bug_data->reporter_id = gpc_get_int( 'reporter_id_' . $p_ptr, $t_bug_data->reporter_id );
    $t_bug_data->handler_id = gpc_get_int( 'handler_id_' . $p_ptr, $t_bug_data->handler_id );
    $t_bug_data->duplicate_id = gpc_get_int( 'duplicate_id_' . $p_ptr, $t_bug_data->duplicate_id );
    $t_bug_data->priority = gpc_get_int( 'priority_' . $p_ptr, $t_bug_data->priority );
    $t_bug_data->severity = gpc_get_int( 'severity_' . $p_ptr, $t_bug_data->severity );
    $t_bug_data->reproducibility = gpc_get_int( 'reproducibility_' . $p_ptr, $t_bug_data->reproducibility );
    $t_bug_data->status = gpc_get_int( 'status_' . $p_ptr, $t_bug_data->status );
    $t_bug_data->resolution = gpc_get_int( 'resolution_' . $p_ptr, $t_bug_data->resolution );
    $t_bug_data->projection = gpc_get_int( 'projection_' . $p_ptr, $t_bug_data->projection );
    $t_bug_data->category = gpc_get_string( 'category_' . $p_ptr, $t_bug_data->category );
    $t_bug_data->eta = gpc_get_int( 'eta_' . $p_ptr, $t_bug_data->eta );
    $t_bug_data->os = gpc_get_string( 'os_' . $p_ptr, $t_bug_data->os );
    $t_bug_data->os_build = gpc_get_string( 'os_build_' . $p_ptr, $t_bug_data->os_build );
    $t_bug_data->platform = gpc_get_string( 'platform_' . $p_ptr, $t_bug_data->platform );
    $t_bug_data->version = gpc_get_string( 'version_' . $p_ptr, $t_bug_data->version );
    $t_bug_data->build = gpc_get_string( 'build_' . $p_ptr, $t_bug_data->build );
    $t_bug_data->fixed_in_version = gpc_get_string( 'fixed_in_version_' . $p_ptr, $t_bug_data->fixed_in_version );
    if ( $g_mantis_is_11x_release ) {
        $t_bug_data->target_version = gpc_get_string( 'target_version_' . $p_ptr, $t_bug_data->target_version );
    }
    $t_bug_data->view_state = gpc_get_int( 'view_state_' . $p_ptr, $t_bug_data->view_state );
    $t_bug_data->summary = gpc_get_string( 'summary_' . $p_ptr, $t_bug_data->summary );
    $t_bug_data->description = gpc_get_string( 'description_' . $p_ptr, $t_bug_data->description );
    $t_bug_data->steps_to_reproduce = gpc_get_string( 'steps_to_reproduce_' . $p_ptr, $t_bug_data->steps_to_reproduce );
    $t_bug_data->additional_information = gpc_get_string( 'additional_information_' . $p_ptr, $t_bug_data->additional_information );

    if ( ( NEW_ == $t_bug_data->status )
	  && ( 0 != $t_bug_data->handler_id )
	  && ( ON == config_get( 'auto_set_status_to_assigned' ) ) ) {
        $t_bug_data->status = config_get( 'bug_assigned_status' );
    }

    helper_call_custom_function( 'issue_update_validate', array( $p_id, $t_bug_data, '' ) );

    $t_resolved = config_get( 'bug_resolved_status_threshold' );

    $t_custom_status_label = 'update';
    if ( $t_bug_data->status == $t_resolved ) {
        $t_custom_status_label = 'resolved';
    }
    if ( $t_bug_data->status == CLOSED ) {
        $t_custom_status_label = 'closed';
    }

    $t_related_custom_field_ids = custom_field_get_linked_ids( $t_bug_data->project_id );
    foreach( $t_related_custom_field_ids as $t_id ) {
        $t_def = custom_field_get_definition( $t_id );
        $t_custom_field_value = gpc_get_custom_field( 'custom_' . $t_def['name'] . '_' . $p_ptr, $t_def['type'], null );

        if( !( $t_def['require_' . $t_custom_status_label] ||
              ( $t_def['display_' . $t_custom_status_label] && in_array( $t_custom_status_label, array( "resolved", "closed" ) ) ) ) ) {
            continue;
        }

        if ( $t_custom_field_value === null ) {
            continue;
        }

        if( !custom_field_has_write_access( $t_id, $p_id ) ) {
            continue;
        }

        if ( $t_def['require_' . $t_custom_status_label] && ( gpc_get_custom_field( 'custom_' . $t_def['name'] . '_' . $p_ptr, $t_def['type'], '' ) == '' ) ) {
            return false;
        }
        if ( !custom_field_set_value( $t_id, $p_id, $t_custom_field_value ) ) {
            return false;
        }
    }

    $t_notify = true;
    $t_bug_note_set = false;
    if ( $t_old_bug_status != $t_bug_data->status ) {
        switch ( $t_bug_data->status ) {
          case $t_resolved:
            bug_resolve( $p_id, $t_bug_data->resolution, $t_bug_data->fixed_in_version,
                        '', $t_bug_data->duplicate_id, $t_bug_data->handler_id, false );
            $t_notify = false;
            $t_bug_note_set = true;

            $t_bug_data->handler_id = bug_get_field( $p_id, 'handler_id' );
            $t_bug_data->status = bug_get_field( $p_id, 'status' );
            break;

          case CLOSED:
            bug_close( $p_id, '', false );
            $t_notify = false;
            $t_bug_note_set = true;
            break;
            
          case config_get( 'bug_reopen_status' ):
            if ( $t_old_bug_status >= $t_resolved ) {
                bug_set_field( $p_id, 'handler_id', $t_bug_data->handler_id );
                bug_reopen( $p_id, '', false );
                $t_notify = false;
                $t_bug_note_set = true;

                $t_bug_data->status = bug_get_field( $p_id, 'status' );
                $t_bug_data->resolution = bug_get_field( $p_id, 'resolution' );
                break;
            }
        }
    }

    bug_update( $p_id, $t_bug_data, true, ( false == $t_notify ) );

    helper_call_custom_function( 'issue_update_notify', array( $p_id ) );
    return true;
}

?>